HDU 3642 求体积交集

Get The Treasury

题目链接

http://acm.hdu.edu.cn/showproblem.php?pid=3642

Problem Description

Jack knows that there is a great underground treasury in a secret region. And he has a special device that can be used to detect treasury under the surface of the earth. One day he got outside with the device to ascertain the treasury. He chose many different locations on the surface of the earth near the secret region. And at each spot he used the device to detect treasury and got some data from it representing a region, which may contain treasury below the surface. The data from the device at each spot is six integers x1, y1, z1, x2, y2 and z2 (x1<x2, y1<y2, z1<z2). According to the instruction of the device they represent the range of x, y and z coordinates of the region. That is to say, the x coordinate of the region, which may contain treasury, ranges from x1 to x2. So do y and z coordinates. The origin of the coordinates is a fixed point under the ground.
Jack can’t get the total volume of the treasury because these regions don’t always contain treasury. Through years of experience, he discovers that if a region is detected that may have treasury at more than two different spots, the region really exist treasure. And now Jack only wants to know the minimum volume of the treasury.
Now Jack entrusts the problem to you.

Input

The first line of the input file contains a single integer t, the number of test cases, followed by the input data for each test case.
Each test case is given in some lines. In the first line there is an integer n (1 ≤ n ≤ 1000), the number of spots on the surface of the earth that he had detected. Then n lines follow, every line contains six integers x1, y1, z1, x2, y2 and z2, separated by a space. The absolute value of x and y coordinates of the vertices is no more than 106, and that of z coordinate is no more than 500.

Output

For each test case, you should output “Case a: b” in a single line. a is the case number, and b is the minimum volume of treasury. The case number is counted from one.

Sample Input

    2
    1
    0 0 0 5 6 4
    3
    0 0 0 5 5 5
    3 3 3 9 10 11
    3 3 3 13 20 45

Sample Output

    Case 1: 0
    Case 2: 8

题意

给你一些立方体,求相交三次或以上的体积和。

题解

昨天做了个求面积交两次或以上的,今天升级了,交三次其实还好,和交两次超不多,但是球体积我就有点懵了,想了好久,不知道咋办。

最终看题解,结果。。。感觉这不是暴力吗?多出来的一维z,先把z排序,然后每次把包含z[i]到z[i+1]的立方体加入到一个零食队列中,求这些立方体的面积并,在乘上(z[i+1]-z[i])。

既然这样可以过,那其实和二维没什么差别了,无非就是代码多了一些,都是套路啊!

代码

#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define INF 0x7f7f7f7f
#define N 1050
ll kthx[N<<1],kthz[N<<1];
template<typename T>void read(T&x)
{
    ll k=0; char c=getchar();
    x=0;
    while(!isdigit(c)&&c!=EOF)k^=c=='-',c=getchar();
    if (c==EOF)exit(0);
    while(isdigit(c))x=x*10+c-'0',c=getchar();
    x=k?-x:x;
}
struct Query
{
    ll l,r,z1,z2,h; int id;
    bool operator<(const Query&e)const
        {return h<e.h;}
}que[N<<1],tmp[N<<1];
struct Node{int l,r,lazy;ll sum,sum2,sum3;};
struct segmentTree
{
    Node tr[N<<3];
    void push_up(int x);
    void bt(int x,int l,int r);
    void update(int x,int l,int r,int tt);
}seg;
void segmentTree::push_up(int x)
{
    ll len=kthx[tr[x].r+1]-kthx[tr[x].l];
    tr[x].sum=0;
    if (tr[x].l<tr[x].r)tr[x].sum=tr[x<<1].sum+tr[x<<1|1].sum;
    if (tr[x].lazy>=1)tr[x].sum=len;
    tr[x].sum2=0;
    if (tr[x].lazy>=2)tr[x].sum2=len;
    if (tr[x].l<tr[x].r&&tr[x].lazy==1)tr[x].sum2=tr[x<<1].sum+tr[x<<1|1].sum;
    if (tr[x].l<tr[x].r&&tr[x].lazy==0)tr[x].sum2=tr[x<<1].sum2+tr[x<<1|1].sum2;
    tr[x].sum3=0;
    if (tr[x].lazy>=3)tr[x].sum3=len;
    if (tr[x].l==tr[x].r)return;
    if (tr[x].lazy==2)tr[x].sum3=tr[x<<1].sum+tr[x<<1|1].sum;
    if (tr[x].lazy==1)tr[x].sum3=tr[x<<1].sum2+tr[x<<1|1].sum2;
    if (tr[x].lazy==0)tr[x].sum3=tr[x<<1].sum3+tr[x<<1|1].sum3;
}
void segmentTree::bt(int x,int l,int r)
{
    tr[x]=Node{l,r,0,0,0,0};
    if(l==r)return;
    int mid=(l+r)>>1;
    bt(x<<1,l,mid);
    bt(x<<1|1,mid+1,r);
}
void segmentTree::update(int x,int l,int r,int tt)
{
    if (l<=tr[x].l&&tr[x].r<=r)
    {
        tr[x].lazy+=tt;
        push_up(x);
        return;
    }
    int mid=(tr[x].l+tr[x].r)>>1;
    if(l<=mid)update(x<<1,l,r,tt);
    if(mid<r)update(x<<1|1,l,r,tt);
    push_up(x);
}
void work()
{
    int m,numx=0,numz=0;
    ll ans=0;
    read(m);
    for(int i=1;i<=m;i++)
    {
        ll x1,y1,z1,x2,y2,z2;
        //scanf("%lld%lld%lld%lld%lld%lld",&x1,&y1,&z1,&x2,&y2,&z2);
        read(x1); read(y1); read(z1); read(x2); read(y2); read(z2);
        que[i]={x1,x2,z1,z2,y1,1};
        que[i+m]={x1,x2,z1,z2,y2,-1};
        kthx[++numx]=x1;
        kthx[++numx]=x2;
        kthz[++numz]=z1;
        kthz[++numz]=z2;
    }
    sort(que+1,que+numx+1);
    sort(kthx+1,kthx+numx+1);
    sort(kthz+1,kthz+numz+1);
    numx=unique(kthx+1,kthx+numx+1)-kthx-1;
    numz=unique(kthz+1,kthz+numz+1)-kthz-1;
    for(int i=1;i<=2*m;i++)
        {
            que[i].l=lower_bound(kthx+1,kthx+numx+1,que[i].l)-kthx;
            que[i].r=lower_bound(kthx+1,kthx+numx+1,que[i].r)-kthx-1;
        }
    seg.bt(1,1,numx);
    for(int j=1;j<=numz-1;j++)
    {
        ll z1=kthz[j],z2=kthz[j+1],tp=0,now=0;
        for(int i=1;i<=2*m;i++)
            if (que[i].z1<=z1&&z2<=que[i].z2)tmp[++now]=que[i];
        for(int i=1;i<=now;i++)
            {
                seg.update(1,tmp[i].l,tmp[i].r,tmp[i].id);
                tp+=seg.tr[1].sum3*(tmp[i+1].h-tmp[i].h);
            }
        ans+=1LL*tp*(z2-z1);
    }
    static int cas;
    printf("Case %d: %lld\n",++cas,ans);
}
int main()
{
#ifndef ONLINE_JUDGE
    freopen("aa.in","r",stdin);
#endif
    int T;
    read(T);
    while(T--)work();
}

原文地址:https://www.cnblogs.com/mmmqqdd/p/11247711.html

时间: 2024-11-13 06:31:09

HDU 3642 求体积交集的相关文章

HDU 3642 Get The Treasury(线段树)

HDU 3642 Get The Treasury 题目链接 题意:给定一些立方体,求体积重叠超过3次的 思路:由于z坐标只有500,那么就可以枚举z坐标,每次做x,y的面积并即可,用线段树维护 代码: #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int N = 1005; const int INF = 0x3f3f3f3f; typedef

hdu 3642 Get The Treasury(扫描线)

题目链接:hdu 3642 Get The Treasury 题目大意:三维坐标系,给定若干的长方体,问说有多少位置被覆盖3次以上. 解题思路:扫描线,将第三维分离出来,就是普通的二维扫描线,然后对于每个节点要维护覆盖0,1,2,3以上这4种的覆盖面积. #include <cstdio> #include <cstring> #include <vector> #include <algorithm> using namespace std; const

HDU 3642 线段树+离散化+扫描线

题意:给你N个长方体的左下角和右上角坐标,问你空间中有多少体积是被大于两个不同的立方体覆盖的.x,y~10^6 z~500 考虑到给的z比较小,所以可以直接枚举z,然后跑二维的扫描线就好. 关于处理被不同的线段覆盖三次的问题,可以维护四个信息,cnt,once,twice,more,然后相互推出结果就好. #include <cstdio> #include <cstring> #include <vector> #include <algorithm> #

hdu 3642 Get The Treasury (三维的扫描线)

题目大意: 给出N个立方体. 求一个三维空间中被包围三次的空间的体积之和. 思路分析: 发现Z的范围很小.那么我们可以枚举Z轴,然后对 x y做扫描线. 而且不用枚举所有的Z ,只需要将Z离散化之后枚举. #include <cstdio> #include <iostream> #include <algorithm> #include <cstring> #define maxn 2222 #define debug puts("fuck!&q

HDU 3642 Get The Treasury 线段树+扫描线

反向标记是错的,要对矩形进行拆分 #include <cstdio> #include <algorithm> #include <cstring> #include <vector> typedef long long LL; using namespace std; #define lson rt << 1,l,mid #define rson rt << 1 | 1,mid + 1,r const int maxn = 5e4

Q - Get The Treasury - HDU 3642 (扫面线求体积)

题意:求被三个或三个以上立方体重合的体积 分析:就是平面面积的加强,不过归根还是一样的,可以把z轴按照从小向大分区间N个,然后可以得到N个平面,用平面重复三次以上的在和高度计算体积. ************************************************************************ #include<stdio.h>#include<algorithm>using namespace std; #define Lson r<<

hdu 3642 Get The Treasury

Get The Treasury http://acm.hdu.edu.cn/showproblem.php?pid=3642 Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Problem Description Jack knows that there is a great underground treasury in a secret region. And he

HDU 3642 - Get The Treasury - [加强版扫描线+线段树]

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3642 Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Problem Description Jack knows that there is a great underground treasury in a secret region. And he has a special d

hdu 3642 Get The Treasure

对于这题,一开始看到z值较小,就像枚举z坐标,然后对于一个单独的z平面做面积交来累加答案..(三个以上柱体的体积交) 搜题解学完up函数的姿势后感觉自己写的还是蛮不错的嘛.. 线段树每个节点包含当前节店的覆盖次数cnt,表示覆盖次数-长度映射的数组,由于只要cnt>=3就可以统计,故数组只开到3.. 由于n只有1000,所以平面交的时候先对于x坐标进行离散化,然后就是扫描线.. 一开始自己的姿势是对于每个z建立一个线段树,但是会mle...后来才改成使用一个重复利用..然后就是没注意到cnt会大